## ros-noetic-mbf-costmap-nav 0.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(mbf_costmap_nav)

find_package(catkin REQUIRED
  COMPONENTS
  costmap_2d
  dynamic_reconfigure
  geometry_msgs
  mbf_abstract_nav
  mbf_costmap_core
  mbf_msgs
  mbf_utility
  nav_core
  nav_msgs
  roscpp
  std_msgs
  std_srvs
  tf
)

find_package(Boost COMPONENTS thread chrono REQUIRED)

# dynamic reconfigure
generate_dynamic_reconfigure_options(
  cfg/MoveBaseFlex.cfg
)

set(MBF_NAV_CORE_WRAPPER_LIB mbf_nav_core_wrapper)
set(MBF_COSTMAP_2D_SERVER_LIB mbf_costmap_server)
set(MBF_COSTMAP_2D_SERVER_NODE mbf_costmap_nav)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${MBF_COSTMAP_2D_SERVER_LIB}
  CATKIN_DEPENDS
  actionlib
  actionlib_msgs
  costmap_2d
  dynamic_reconfigure
  geometry_msgs
  mbf_abstract_nav
  mbf_costmap_core
  mbf_msgs
  mbf_utility
  nav_core
  nav_msgs
  pluginlib
  roscpp
  std_msgs
  std_srvs
  tf
  DEPENDS Boost
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
)

add_library(${MBF_NAV_CORE_WRAPPER_LIB}
  src/nav_core_wrapper/wrapper_global_planner.cpp
  src/nav_core_wrapper/wrapper_local_planner.cpp
  src/nav_core_wrapper/wrapper_recovery_behavior.cpp
)
add_dependencies(${MBF_NAV_CORE_WRAPPER_LIB} ${catkin_EXPORTED_TARGETS})
target_link_libraries(${MBF_NAV_CORE_WRAPPER_LIB}
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
)

add_library(${MBF_COSTMAP_2D_SERVER_LIB}
  src/mbf_costmap_nav/costmap_navigation_server.cpp
  src/mbf_costmap_nav/costmap_planner_execution.cpp
  src/mbf_costmap_nav/costmap_controller_execution.cpp
  src/mbf_costmap_nav/costmap_recovery_execution.cpp
  src/mbf_costmap_nav/costmap_wrapper.cpp
  src/mbf_costmap_nav/footprint_helper.cpp
)
add_dependencies(${MBF_COSTMAP_2D_SERVER_LIB} ${catkin_EXPORTED_TARGETS})
add_dependencies(${MBF_COSTMAP_2D_SERVER_LIB} ${MBF_NAV_CORE_WRAPPER_LIB})
add_dependencies(${MBF_COSTMAP_2D_SERVER_LIB} ${PROJECT_NAME}_gencfg)

target_link_libraries(${MBF_COSTMAP_2D_SERVER_LIB}
  ${MBF_NAV_CORE_WRAPPER_LIB}
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
)

add_executable(${MBF_COSTMAP_2D_SERVER_NODE} src/move_base_server_node.cpp)
add_dependencies(${MBF_COSTMAP_2D_SERVER_NODE} ${MBF_COSTMAP_2D_SERVER_LIB})
target_link_libraries(${MBF_COSTMAP_2D_SERVER_NODE}
  ${MBF_COSTMAP_2D_SERVER_LIB}
  ${catkin_LIBRARIES}
)

install(TARGETS
  ${MBF_NAV_CORE_WRAPPER_LIB} ${MBF_COSTMAP_2D_SERVER_LIB} ${MBF_COSTMAP_2D_SERVER_NODE}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

catkin_install_python(PROGRAMS scripts/move_base_legacy_relay.py
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

=== debian/changelog ===
ros-noetic-mbf-costmap-nav (0.4.0-1focal) focal; urgency=high

  * make the costmaps used for planning and controlling configurable, see #278
  * return empty footprint if partly outside of the map, see #272
  * add tf_transform_ptr to the abstract planner execution, see #256
  * transform pose to global frame before calling planner in costmap planner execution, see #256

 -- Sebastian Pütz <spuetz@uos.de>  Mon, 25 Oct 2021 22:00:00 -0000

ros-noetic-mbf-costmap-nav (0.3.4-1focal) focal; urgency=high

  * fix blind driving, see #243

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 01 Dec 2020 23:00:00 -0000

ros-noetic-mbf-costmap-nav (0.3.3-1focal) focal; urgency=high

  * Fix controller fails if robot pose gets older than tf_timeout, see #231
  * clear the costmap before deactivating it, see #220
  * Use catkin_install_python to install legacy relay. see #219
  * For move_base_legacy_relay, keep configured base local and global planners to send to MBF, see #209
  * Fix deallocation on shutdown by discarding all plugins and resetting action server pointers, see #199
  * Make reference symbol position consistent across the project, see #198
  * Move RobotInformation to mbf_utility, as it can be used generaly, see #196
  * Prevent unrelated type casts for Cell, see #197

 -- Sebastian Pütz <spuetz@uos.de>  Wed, 04 Nov 2020 23:00:00 -0000

ros-noetic-mbf-costmap-nav (0.3.2-1focal) focal; urgency=high

  * Remove dependency on base_local_planner and move FootprintHelper class to mbf_costmap_nav and make it static

 -- Sebastian Pütz <spuetz@uos.de>  Sun, 24 May 2020 22:00:00 -0000

ros-noetic-mbf-costmap-nav (0.3.1-1focal) focal; urgency=high

  * Ensure that check_costmap_mutex is destroyed after timer.
  * Avoid crash on shutdown by stop shutdown_costmap_timer on destructor
    and explicitly call the costmap_nav_srv destructor

 -- Sebastian Pütz <spuetz@uos.de>  Mon, 06 Apr 2020 22:00:00 -0000

ros-noetic-mbf-costmap-nav (0.3.0-1focal) focal; urgency=high

  * add output for cancel method if nav_core plugin is wrapped
  * unify license declaration to BSD-3

 -- Sebastian Pütz <spuetz@uos.de>  Mon, 30 Mar 2020 22:00:00 -0000

ros-noetic-mbf-costmap-nav (0.2.5-1focal) focal; urgency=high

  * Add clear_on_shutdown functionality
  * Do not pass boost functions to abstract server to (de)activate costmaps.
    Run instead abstract methods (possibly) overridden in the costmap server,
    all costmap-related handling refactored to a new CostmapWrapper class
  * On controller execution, check that local costmap is current

 -- Sebastian Pütz <spuetz@uos.de>  Thu, 10 Oct 2019 22:00:00 -0000

ros-noetic-mbf-costmap-nav (0.2.4-1focal) focal; urgency=high

  * Add check_point_cost service
  * Lock costmaps on clear_costmaps service
  * Replace recursive mutexes with normal ones when not needed

 -- Sebastian Pütz <spuetz@uos.de>  Sat, 15 Jun 2019 22:00:00 -0000

ros-noetic-mbf-costmap-nav (0.2.3-1focal) focal; urgency=high

  * single publisher for controller execution objects

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 13 Nov 2018 23:00:00 -0000

ros-noetic-mbf-costmap-nav (0.2.2-1focal) focal; urgency=high

  * Do not use MultiThreadedSpinner, as costmap updates can crash when combining laser scans and point clouds
  * Make start/stop costmaps mutexed, since concurrent calls to start can lead to segfaults

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 09 Oct 2018 22:00:00 -0000

ros-noetic-mbf-costmap-nav (0.2.1-1focal) focal; urgency=high

  * Make MBF melodic and indigo compatible
  * Fix GoalHandle references bug in callbacks

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 02 Oct 2018 22:00:00 -0000

ros-noetic-mbf-costmap-nav (0.2.0-1focal) focal; urgency=high

  * Update copyright and 3-clause-BSD license
  * Concurrency for planners, controllers and recovery behaviors

 -- Sebastian Pütz <spuetz@uos.de>  Mon, 10 Sep 2018 22:00:00 -0000

ros-noetic-mbf-costmap-nav (0.1.0-1focal) focal; urgency=high

  * First release of move_base_flex for kinetic and lunar

 -- Sebastian Pütz <spuetz@uos.de>  Wed, 21 Mar 2018 23:00:00 -0000

=== debian/control ===
Source: ros-noetic-mbf-costmap-nav
Section: misc
Priority: optional
Maintainer: Sebastian Pütz <spuetz@uos.de>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-actionlib, ros-noetic-actionlib-msgs, ros-noetic-catkin, ros-noetic-costmap-2d, ros-noetic-dynamic-reconfigure, ros-noetic-geometry-msgs, ros-noetic-mbf-abstract-nav, ros-noetic-mbf-costmap-core, ros-noetic-mbf-msgs, ros-noetic-mbf-utility, ros-noetic-nav-core, ros-noetic-nav-msgs, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf
Homepage: http://wiki.ros.org/move_base_flex
Standards-Version: 3.9.2

Package: ros-noetic-mbf-costmap-nav
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-actionlib, ros-noetic-actionlib-msgs, ros-noetic-costmap-2d, ros-noetic-dynamic-reconfigure, ros-noetic-geometry-msgs, ros-noetic-mbf-abstract-nav, ros-noetic-mbf-costmap-core, ros-noetic-mbf-msgs, ros-noetic-mbf-utility, ros-noetic-move-base, ros-noetic-move-base-msgs, ros-noetic-nav-core, ros-noetic-nav-msgs, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf
Description: The mbf_costmap_nav package contains the costmap navigation server implementation of Move Base Flex (MBF).
 The costmap navigation server is bound to the costmap_2d representation. It provides the Actions for planning, controlling and recovering. At the time of start MBF loads all defined plugins. Therefor, it loads all plugins which are defined in the lists *planners*, *controllers* and *recovery_behaviors*. Each list holds a pair of a *name* and a *type*. The *type* defines which kind of plugin to load. The *name* defines under which name the plugin should be callable by the actions. Additionally the mbf_costmap_nav package comes with a wrapper for the old navigation stack and the plugins which inherits from the nav_core base classes. Preferably it tries to load plugins for the new API. However, plugins could even support both move_base and move_base_flex by inheriting both base class interfaces located in the nav_core package and in the mbf_costmap_core package.
